from typing import Dict, List, Optional
from app.services.external_api.tcgplayer.base_tcgplayer_service import BaseTCGPlayerService

class TCGPlayerInventoryService(BaseTCGPlayerService):
    def __init__(self):
        super().__init__()

    async def get_inventory(self) -> List[Dict]:
        """Get inventory items"""
        endpoint = "/inventory"
        response = await self._make_request("GET", endpoint)
        return response.get("results", [])

    async def update_inventory(self, updates: List[Dict]) -> Dict:
        """Update inventory items"""
        endpoint = "/inventory"
        response = await self._make_request("PUT", endpoint, data=updates)
        return response
